package WD::Counter::Moderate;

use strict;
use warnings;
use base qw/WD::Counter/;
use URI::Escape;

our $BLOCKING_TIME = 5*60;
our $BLOCKING_KEY = 'counter_block:%s';

sub incr_memcached {
    my $self = shift;

    my $key = URI::Escape::uri_escape($self->{query}->remote_host, "\x00-\x1f\x20\x7f");
    my $ret = $self->{memcached}->add( $BLOCKING_KEY.$key, 1, $BLOCKING_TIME );

    if ( $ret ) {
       return $self->SUPER::incr_memcached();
    }

    $self->{memcached}->get( $self->counter_key );
}

1;
